SystemOrganization addCategory: #'GT-SpotterExtensions-CoreRoassal'!

!RTElement methodsFor: '*GT-SpotterExtensions-CoreRoassal' stamp: 'AlexandreBergel 1/9/2015 18:08'!
spotterActDefault
	self view canvas camera translateTo: self position.
	RTBlink on: self.! !

RTInteraction subclass: #RTFindInAView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-SpotterExtensions-CoreRoassal'!

!RTFindInAView methodsFor: 'hooks' stamp: 'AliakseiSyrel 1/19/2015 21:36'!
initializeElement: aView

	| mb |
	mb := RTMenuBuilder new.
	mb view: aView.
	mb menu: 'Find' callback: [ 
        GTSpotterMorph new
                        extent: 400@500;
                        spotterModel: (GTSpotter on: aView);
                        openCenteredInWorld ].
	mb build! !

!GTSpotter methodsFor: '*GT-SpotterExtensions-CoreRoassal' stamp: 'AndreiChis 12/8/2014 20:18'!
spotterRoassalExamplesFor: aStep
	<spotterOrder: 500>
	aStep listProcessor 
			allCandidates: [ (RTAbstractExample allSubclasses collect: #new) 
				flatCollect: [ :each | each gtExamples ] ];
			title: 'Roassal Examples';
			itemName: [ :example | example selector ];
			itemIcon: [ :example | example iconForm ];
			matchSubstringByQueryParts;
			wantsToDisplayOnEmptyQuery: false! !

!RTExampleSelection methodsFor: '*GT-SpotterExtensions-CoreRoassal' stamp: 'AndreiChis 12/8/2014 19:57'!
matchesQuery: aSetOfNames
	| sourceCode |
	
	sourceCode := (self exampleObject class >> self selector) sourceCode asLowercase.
	^ aSetOfNames allSatisfy: [ :each | sourceCode includesSubstring: each ]
! !

!GTSpotterCandidatesListProcessor methodsFor: '*GT-SpotterExtensions-CoreRoassal' stamp: 'AndreiChis 12/8/2014 20:16'!
matchSubstringByQueryParts
	self filter: [ :originalQuery :stream | | query aCollection|
				query := originalQuery trimBoth asLowercase.
				query isEmpty 
					ifTrue: [ self streamAllCandidatesOn: stream ]
					ifFalse: [
							aCollection := OrderedCollection new.
							self allCandidates do: [ :each | 
								(each matchesQuery: (originalQuery trimBoth asLowercase splitOn: ' ')) 
									ifTrue: [ 
										aCollection add: each.
										aCollection size > 5 ifFalse: [ stream addObject: each inProcessor: self ] ] ] ].
				aCollection ]! !

!RTView methodsFor: '*GT-SpotterExtensions-CoreRoassal' stamp: 'AlexandreBergel 1/9/2015 18:03'!
spotterElementsFor: aStep
	<spotterOrder: 10>
	^ aStep listProcessor
		title: 'Elements';
		candidatesLimit: 100;
		allCandidates: [ self elements ];
		itemName: [ :each | each model gtDisplayString ];
		matchSubstring;
		wantsToDisplayOnEmptyQuery: true! !
